"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

Object subclass:#AJCallInfo
	instanceVariableNames:'asm stackAlignment stackSize arguments callCleanup prepareForCall
		noCleanup alignInsertionPoint'
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-StackManagement'
!

AJCallInfo comment:''
!

!AJCallInfo class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!AJCallInfo methodsFor:'accessing'!

alignment: aStackAlignment
    stackAlignment := aStackAlignment
!

alignmentInsertionPoint: instruction
    alignInsertionPoint := instruction
!

asm: assembler
    asm := assembler
!

callCleanup: aCallCleanup
    self assert: callCleanup isNil.
    
    callCleanup := aCallCleanup 
!

defaultArgumentSize
    self subclassResponsibility 
!

disableCleanup 
    noCleanup := true
!

name
    ^ 'call info' 
!

noCleanup 
    ^ noCleanup 
!

noticeArgument: aCallArgument

    arguments add: aCallArgument.
    stackSize := stackSize + aCallArgument size.
!

stackSize
    ^ stackSize
!

stackSize: anObject
    stackSize := anObject
! !

!AJCallInfo methodsFor:'initialize-release'!

initialize
    arguments := OrderedCollection new.
    stackSize := 0.
    stackAlignment := 1.
    noCleanup := false.
! !

!AJCallInfo methodsFor:'pushing args'!

push: anArgument
    
    asm pushArgument: anArgument forCall: self.
! !

!AJCallInfo methodsFor:'testing'!

needsAlignment
    ^ stackAlignment > 1
! !

