"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJBaseReg subclass:#AJMMRegister
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-x86-Operands'
!

AJMMRegister comment:'I am register used for the MMX integer instructions on IA-32 processors.

MMX registers are 64Bit wide, depending on the instructions used the register is used either as 1 x 64bit value, 2 x 32bit values, 4 x 16bit values or 8 x 8bit values.

Note that the MMX register overlap with the floating point register and only use the lower 64bits of the 80bits FPU registers.'
!

!AJMMRegister methodsFor:'accessing'!

code: aCode

    code := aCode.
    size := 8.
!

influencingRegisters
    "MMX registers overlap with the ST register"
    self shouldBeImplemented.
! !

!AJMMRegister methodsFor:'printing'!

descriptionOn: s
    
    s nextPutAll: 'An MMX register'.
! !

!AJMMRegister methodsFor:'testing'!

isGeneralPurpose
    ^ false
!

isRegTypeMM
    ^ true
!

isX86
    ^ true
! !

