"{ Package: 'jv:dragonfly/asm' }"

"{ NameSpace: Smalltalk }"

AJInstruction subclass:#AJRoutinePrologue
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'AsmJit-Instructions'
!

AJRoutinePrologue comment:'This is a pseudo-instruction to indicate a place in native code for routine prologue.
It is later replaced by real instructions which contain code for initializing stack frame & extra stack space required by routine.'
!

!AJRoutinePrologue methodsFor:'accessing'!

name
    ^ 'prologue' 
! !

!AJRoutinePrologue methodsFor:'emitting code'!

emitCode: asm
    machineCode := #[]
! !

!AJRoutinePrologue methodsFor:'visitor'!

accept: anObject
    ^ anObject visitRoutinePrologue: self
!

setPrologue: anInstructions
    "do nothing"
    | old |
    old := next.
    next := anInstructions.
    anInstructions last next: old 
! !

