"{ Package: 'jv:dragonfly' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#jv_dragonfly
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jv_dragonfly class methodsFor:'description'!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:libbasic'    "ArrayedCollection - superclass of CompiledCodeObjectSection"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for compiling or loading,
     however, a class from it may be referenced during execution and having it
     unloaded then may lead to a runtime doesNotUnderstand error, unless the caller
     includes explicit checks for the package being present.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
        #'jv:dragonfly/udis86sx'    "UDIS86 - referenced by CompiledCodeObjectSection>>inspector2TabAssembly"
        #'stx:goodies/sunit'    "TestAsserter - superclass of CompiledCodeObjectTests"
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites."

    ^ #(
        #'jv:dragonfly/udis86sx'
    )
! !

!jv_dragonfly class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        CompiledCodeObject
        CompiledCodeObjectSectionType
        #'jv_dragonfly'
        CompiledCodeObjectSection
        (CompiledCodeObjectTests autoload)
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
        CompiledCode codeObject
        CompiledCode inspector2TabMachineCode
    )
! !

!jv_dragonfly class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

